Index: apache-tomcat-9.0.33-src/java/org/apache/catalina/connector/InputBuffer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/catalina/connector/InputBuffer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/catalina/connector/InputBuffer.java
@@ -389,10 +389,10 @@ public class InputBuffer extends Reader
         }
         int n = Math.min(to.remaining(), bb.remaining());
         int orgLimit = bb.limit();
-        bb.limit(bb.position() + n);
+        ((Buffer)bb).limit(bb.position() + n);
         to.put(bb);
-        bb.limit(orgLimit);
-        to.limit(to.position()).position(to.position() - n);
+        ((Buffer)bb).limit(orgLimit);
+        ((Buffer)to).limit(to.position()).position(to.position() - n);
         return n;
     }
 
@@ -488,11 +488,11 @@ public class InputBuffer extends Reader
         long nRead = 0;
         while (nRead < n) {
             if (cb.remaining() >= n) {
-                cb.position(cb.position() + (int) n);
+                ((Buffer)cb).position(cb.position() + (int) n);
                 nRead = n;
             } else {
                 nRead += cb.remaining();
-                cb.position(cb.limit());
+                ((Buffer)cb).position(cb.limit());
                 int nb = realReadChars();
                 if (nb < 0) {
                     break;
@@ -533,7 +533,7 @@ public class InputBuffer extends Reader
         } else {
             if ((cb.capacity() > (2 * size)) && (cb.remaining()) < (cb.position())) {
                 cb.compact();
-                cb.flip();
+                ((Buffer)cb).flip();
             }
         }
         readLimit = cb.position() + readAheadLimit + size;
@@ -554,7 +554,7 @@ public class InputBuffer extends Reader
                 markPos = -1;
                 throw new IOException();
             } else {
-                cb.position(markPos);
+                ((Buffer)cb).position(markPos);
             }
         } else {
             clear(bb);
@@ -672,10 +672,10 @@ public class InputBuffer extends Reader
 
         CharBuffer tmp = CharBuffer.allocate(newSize);
         int oldPosition = cb.position();
-        cb.position(0);
+        ((Buffer)cb).position(0);
         tmp.put(cb);
-        tmp.flip();
-        tmp.position(oldPosition);
+        ((Buffer)tmp).flip();
+        ((Buffer)tmp).position(oldPosition);
         cb = tmp;
         tmp = null;
     }
Index: apache-tomcat-9.0.33-src/java/org/apache/catalina/connector/OutputBuffer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/catalina/connector/OutputBuffer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/catalina/connector/OutputBuffer.java
@@ -761,10 +761,10 @@ public class OutputBuffer extends Writer
         int limit = bb.capacity();
         int fromLimit = from.limit();
         while (from.remaining() >= limit) {
-            from.limit(from.position() + limit);
+            ((Buffer)from).limit(from.position() + limit);
             realWriteBytes(from.slice());
-            from.position(from.limit());
-            from.limit(fromLimit);
+            ((Buffer)from).position(from.limit());
+            ((Buffer)from).limit(fromLimit);
         }
 
         if (from.remaining() > 0) {
Index: apache-tomcat-9.0.33-src/java/org/apache/catalina/tribes/transport/nio/NioReplicationTask.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/catalina/tribes/transport/nio/NioReplicationTask.java
+++ apache-tomcat-9.0.33-src/java/org/apache/catalina/tribes/transport/nio/NioReplicationTask.java
@@ -18,6 +18,7 @@
 package org.apache.catalina.tribes.transport.nio;
 import java.io.IOException;
 import java.net.SocketAddress;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.CancelledKeyException;
 import java.nio.channels.DatagramChannel;
@@ -80,7 +81,7 @@ public class NioReplicationTask extends
                 buffer = ByteBuffer.allocate(size);
             }
         } else {
-            buffer.clear();
+            ((Buffer)buffer).clear();
         }
         if (key == null) {
             return; // just in case
@@ -156,30 +157,30 @@ public class NioReplicationTask extends
         reader.access();
         ReadableByteChannel channel = (ReadableByteChannel) key.channel();
         int count=-1;
-        buffer.clear();         // make buffer empty
+        ((Buffer)buffer).clear();         // make buffer empty
         SocketAddress saddr = null;
 
         if (channel instanceof SocketChannel) {
             // loop while data available, channel is non-blocking
             while ((count = channel.read (buffer)) > 0) {
-                buffer.flip();      // make buffer readable
+                ((Buffer)buffer).flip();      // make buffer readable
                 if ( buffer.hasArray() )
                     reader.append(buffer.array(),0,count,false);
                 else
                     reader.append(buffer,count,false);
-                buffer.clear();     // make buffer empty
+                ((Buffer)buffer).clear();     // make buffer empty
                 //do we have at least one package?
                 if ( reader.hasPackage() ) break;
             }
         } else if (channel instanceof DatagramChannel) {
             DatagramChannel dchannel = (DatagramChannel)channel;
             saddr = dchannel.receive(buffer);
-            buffer.flip();      // make buffer readable
+            ((Buffer)buffer).flip();      // make buffer readable
             if ( buffer.hasArray() )
                 reader.append(buffer.array(),0,buffer.limit()-buffer.position(),false);
             else
                 reader.append(buffer,buffer.limit()-buffer.position(),false);
-            buffer.clear();     // make buffer empty
+            ((Buffer)buffer).clear();     // make buffer empty
             //did we get a package
             count = reader.hasPackage()?1:-1;
         }
Index: apache-tomcat-9.0.33-src/java/org/apache/catalina/tribes/transport/nio/NioSender.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/catalina/tribes/transport/nio/NioSender.java
+++ apache-tomcat-9.0.33-src/java/org/apache/catalina/tribes/transport/nio/NioSender.java
@@ -20,6 +20,7 @@ package org.apache.catalina.tribes.trans
 import java.io.EOFException;
 import java.io.IOException;
 import java.net.InetSocketAddress;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.channels.DatagramChannel;
 import java.nio.channels.SelectionKey;
@@ -173,9 +174,9 @@ public class NioSender extends AbstractS
         if ( read == -1 ) throw new IOException(sm.getString("nioSender.unable.receive.ack"));
         //no data read
         else if ( read == 0 ) return false;
-        readbuf.flip();
+        ((Buffer)readbuf).flip();
         ackbuf.append(readbuf,read);
-        readbuf.clear();
+        ((Buffer)readbuf).clear();
         if (ackbuf.doesPackageExist() ) {
             byte[] ackcmd = ackbuf.extractDataPackage(true).getBytes();
             boolean ack = Arrays.equals(ackcmd,org.apache.catalina.tribes.transport.Constants.ACK_DATA);
@@ -225,12 +226,12 @@ public class NioSender extends AbstractS
         if ( readbuf == null ) {
             readbuf = getReadBuffer();
         } else {
-            readbuf.clear();
+            ((Buffer)readbuf).clear();
         }
         if ( writebuf == null ) {
             writebuf = getWriteBuffer();
         } else {
-            writebuf.clear();
+            ((Buffer)writebuf).clear();
         }
 
         if (isUdpBased()) {
@@ -317,8 +318,8 @@ public class NioSender extends AbstractS
         if ( isConnected() && readbuf == null) {
             readbuf = getReadBuffer();
         }
-        if ( readbuf != null ) readbuf.clear();
-        if ( writebuf != null ) writebuf.clear();
+        if ( readbuf != null ) ((Buffer)readbuf).clear();
+        if ( writebuf != null ) ((Buffer)writebuf).clear();
         current = null;
         ackbuf.clear();
         remaining = 0;
@@ -357,7 +358,7 @@ public class NioSender extends AbstractS
                 remaining = length;
                 ackbuf.clear();
                 if (writebuf != null) {
-                    writebuf.clear();
+                    ((Buffer)writebuf).clear();
                 } else {
                     writebuf = getBuffer(length);
                 }
@@ -367,7 +368,7 @@ public class NioSender extends AbstractS
 
                 // TODO use ByteBuffer.wrap to avoid copying the data.
                 writebuf.put(data,offset,length);
-                writebuf.flip();
+                ((Buffer)writebuf).flip();
                 if (isConnected()) {
                     if (isUdpBased())
                         dataChannel.register(getSelector(), SelectionKey.OP_WRITE, this);
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/ajp/AjpProcessor.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/ajp/AjpProcessor.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/ajp/AjpProcessor.java
@@ -21,6 +21,7 @@ import java.io.EOFException;
 import java.io.IOException;
 import java.io.InterruptedIOException;
 import java.net.InetAddress;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.security.NoSuchProviderException;
 import java.security.cert.CertificateFactory;
@@ -1260,7 +1261,7 @@ public class AjpProcessor extends Abstra
 
             responseMessage.reset();
             responseMessage.appendByte(Constants.JK_AJP13_SEND_BODY_CHUNK);
-            chunk.limit(chunk.position() + thisTime);
+            ((Buffer)chunk).limit(chunk.position() + thisTime);
             responseMessage.appendBytes(chunk);
             responseMessage.end();
             socketWrapper.write(blocking, responseMessage.getBuffer(), 0, responseMessage.getLen());
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/BufferedInputFilter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/filters/BufferedInputFilter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/BufferedInputFilter.java
@@ -18,6 +18,7 @@
 package org.apache.coyote.http11.filters;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.BufferOverflowException;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
@@ -68,7 +69,7 @@ public class BufferedInputFilter impleme
     public void setLimit(int limit) {
         if (buffered == null) {
             buffered = ByteBuffer.allocate(limit);
-            buffered.flip();
+            ((Buffer)buffered).flip();
         }
     }
 
@@ -84,9 +85,9 @@ public class BufferedInputFilter impleme
         // save off the Request body
         try {
             while (buffer.doRead(this) >= 0) {
-                buffered.mark().position(buffered.limit()).limit(buffered.capacity());
+                ((Buffer)buffered).mark().position(buffered.limit()).limit(buffered.capacity());
                 buffered.put(tempRead);
-                buffered.limit(buffered.position()).reset();
+                ((Buffer)buffered).limit(buffered.position()).reset();
                 tempRead = null;
             }
         } catch(IOException | BufferOverflowException ioe) {
@@ -121,7 +122,7 @@ public class BufferedInputFilter impleme
             if (buffered.capacity() > 65536) {
                 buffered = null;
             } else {
-                buffered.position(0).limit(0);
+                ((Buffer)buffered).position(0).limit(0);
             }
         }
         hasRead = false;
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/ChunkedInputFilter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/filters/ChunkedInputFilter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/ChunkedInputFilter.java
@@ -18,6 +18,7 @@ package org.apache.coyote.http11.filters
 
 import java.io.EOFException;
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 import java.util.Locale;
@@ -184,14 +185,14 @@ public class ChunkedInputFilter implemen
             if (readChunk != handler.getByteBuffer()) {
                 handler.setByteBuffer(readChunk.duplicate());
             }
-            readChunk.position(readChunk.limit());
+            ((Buffer)readChunk).position(readChunk.limit());
         } else {
             result = remaining;
             if (readChunk != handler.getByteBuffer()) {
                 handler.setByteBuffer(readChunk.duplicate());
                 handler.getByteBuffer().limit(readChunk.position() + remaining);
             }
-            readChunk.position(readChunk.position() + remaining);
+            ((Buffer)readChunk).position(readChunk.position() + remaining);
             remaining = 0;
             //we need a CRLF
             if ((readChunk.position() + 1) >= readChunk.limit()) {
@@ -263,7 +264,7 @@ public class ChunkedInputFilter implemen
     public void recycle() {
         remaining = 0;
         if (readChunk != null) {
-            readChunk.position(0).limit(0);
+            ((Buffer)readChunk).position(0).limit(0);
         }
         endChunk = false;
         needCRLFParse = false;
@@ -363,7 +364,7 @@ public class ChunkedInputFilter implemen
 
             // Parsing the CRLF increments pos
             if (!eol) {
-                readChunk.position(readChunk.position() + 1);
+                ((Buffer)readChunk).position(readChunk.position() + 1);
             }
         }
 
@@ -415,7 +416,7 @@ public class ChunkedInputFilter implemen
                 throwIOException(sm.getString("chunkedInputFilter.invalidCrlf"));
             }
 
-            readChunk.position(readChunk.position() + 1);
+            ((Buffer)readChunk).position(readChunk.position() + 1);
         }
     }
 
@@ -484,7 +485,7 @@ public class ChunkedInputFilter implemen
                 trailingHeaders.append(chr);
             }
 
-            readChunk.position(readChunk.position() + 1);
+            ((Buffer)readChunk).position(readChunk.position() + 1);
 
         }
         int colonPos = trailingHeaders.getEnd();
@@ -513,7 +514,7 @@ public class ChunkedInputFilter implemen
 
                 chr = readChunk.get(readChunk.position());
                 if ((chr == Constants.SP) || (chr == Constants.HT)) {
-                    readChunk.position(readChunk.position() + 1);
+                    ((Buffer)readChunk).position(readChunk.position() + 1);
                     // If we swallow whitespace, make sure it counts towards the
                     // limit placed on trailing header size
                     int newlimit = trailingHeaders.getLimit() -1;
@@ -549,7 +550,7 @@ public class ChunkedInputFilter implemen
                 }
 
                 if (!eol) {
-                    readChunk.position(readChunk.position() + 1);
+                    ((Buffer)readChunk).position(readChunk.position() + 1);
                 }
             }
 
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/ChunkedOutputFilter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/filters/ChunkedOutputFilter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/ChunkedOutputFilter.java
@@ -18,6 +18,7 @@ package org.apache.coyote.http11.filters
 
 import java.io.IOException;
 import java.io.OutputStreamWriter;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 import java.util.HashSet;
@@ -106,12 +107,12 @@ public class ChunkedOutputFilter impleme
 
         int pos = calculateChunkHeader(result);
 
-        chunkHeader.position(pos).limit(10);
+        ((Buffer)chunkHeader).position(pos).limit(10);
         buffer.doWrite(chunkHeader);
 
         buffer.doWrite(chunk);
 
-        chunkHeader.position(8).limit(10);
+        ((Buffer)chunkHeader).position(8).limit(10);
         buffer.doWrite(chunkHeader);
 
         return result;
@@ -171,10 +172,10 @@ public class ChunkedOutputFilter impleme
         if (trailerFields == null) {
             // Write end chunk
             buffer.doWrite(endChunk);
-            endChunk.position(0).limit(endChunk.capacity());
+            ((Buffer)endChunk).position(0).limit(endChunk.capacity());
         } else {
             buffer.doWrite(lastChunk);
-            lastChunk.position(0).limit(lastChunk.capacity());
+            ((Buffer)lastChunk).position(0).limit(lastChunk.capacity());
 
            ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
            OutputStreamWriter osw = new OutputStreamWriter(baos, StandardCharsets.ISO_8859_1);
@@ -194,7 +195,7 @@ public class ChunkedOutputFilter impleme
             buffer.doWrite(ByteBuffer.wrap(baos.toByteArray()));
 
             buffer.doWrite(crlfChunk);
-            crlfChunk.position(0).limit(crlfChunk.capacity());
+            ((Buffer)crlfChunk).position(0).limit(crlfChunk.capacity());
         }
         buffer.end();
     }
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/IdentityInputFilter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/filters/IdentityInputFilter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/IdentityInputFilter.java
@@ -18,6 +18,7 @@
 package org.apache.coyote.http11.filters;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 
@@ -104,7 +105,7 @@ public class IdentityInputFilter impleme
                     // The chunk is longer than the number of bytes remaining
                     // in the body; changing the chunk length to the number
                     // of bytes remaining
-                    handler.getByteBuffer().limit(handler.getByteBuffer().position() + (int) remaining);
+                    ((Buffer)(handler.getByteBuffer())).limit(handler.getByteBuffer().position() + (int) remaining);
                     result = (int) remaining;
                 } else {
                     result = nRead;
@@ -116,7 +117,7 @@ public class IdentityInputFilter impleme
                 // No more bytes left to be read : return -1 and clear the
                 // buffer
                 if (handler.getByteBuffer() != null) {
-                    handler.getByteBuffer().position(0).limit(0);
+                    ((Buffer)(handler.getByteBuffer())).position(0).limit(0);
                 }
                 result = -1;
             }
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/IdentityOutputFilter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/filters/IdentityOutputFilter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/IdentityOutputFilter.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http11.filters;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.apache.coyote.Response;
@@ -64,7 +65,7 @@ public class IdentityOutputFilter implem
                     // The chunk is longer than the number of bytes remaining
                     // in the body; changing the chunk length to the number
                     // of bytes remaining
-                    chunk.limit(chunk.position() + (int) remaining);
+                    ((Buffer)chunk).limit(chunk.position() + (int) remaining);
                     result = (int) remaining;
                     remaining = 0;
                 } else {
@@ -74,8 +75,8 @@ public class IdentityOutputFilter implem
             } else {
                 // No more bytes left to be written : return -1 and clear the
                 // buffer
-                chunk.position(0);
-                chunk.limit(0);
+                ((Buffer)chunk).position(0);
+                ((Buffer)chunk).limit(0);
                 result = -1;
             }
         } else {
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/SavedRequestInputFilter.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/filters/SavedRequestInputFilter.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/filters/SavedRequestInputFilter.java
@@ -18,6 +18,7 @@
 package org.apache.coyote.http11.filters;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 
 import org.apache.coyote.InputBuffer;
@@ -51,7 +52,7 @@ public class SavedRequestInputFilter imp
             return -1;
 
         ByteBuffer byteBuffer = handler.getByteBuffer();
-        byteBuffer.position(byteBuffer.limit()).limit(byteBuffer.capacity());
+        ((Buffer)byteBuffer).position(byteBuffer.limit()).limit(byteBuffer.capacity());
         input.subtract(byteBuffer);
 
         return byteBuffer.remaining();
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/Http11InputBuffer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/Http11InputBuffer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/Http11InputBuffer.java
@@ -18,6 +18,7 @@ package org.apache.coyote.http11;
 
 import java.io.EOFException;
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.nio.charset.StandardCharsets;
 import java.util.Arrays;
@@ -265,7 +266,7 @@ public class Http11InputBuffer implement
             activeFilters[i].recycle();
         }
 
-        byteBuffer.limit(0).position(0);
+        ((Buffer)byteBuffer).limit(0).position(0);
         lastActiveFilter = -1;
         parsingHeader = true;
         swallowInput = true;
@@ -295,10 +296,10 @@ public class Http11InputBuffer implement
             if (byteBuffer.remaining() > 0) {
                 // Copy leftover bytes to the beginning of the buffer
                 byteBuffer.compact();
-                byteBuffer.flip();
+                ((Buffer)byteBuffer).flip();
             } else {
                 // Reset position and limit to 0
-                byteBuffer.position(0).limit(0);
+                ((Buffer)byteBuffer).position(0).limit(0);
             }
         }
 
@@ -382,7 +383,7 @@ public class Http11InputBuffer implement
                 }
                 chr = byteBuffer.get();
             } while ((chr == Constants.CR) || (chr == Constants.LF));
-            byteBuffer.position(byteBuffer.position() - 1);
+            ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
 
             parsingRequestLineStart = byteBuffer.position();
             parsingRequestLinePhase = 2;
@@ -412,7 +413,7 @@ public class Http11InputBuffer implement
                     request.method().setBytes(byteBuffer.array(), parsingRequestLineStart,
                             pos - parsingRequestLineStart);
                 } else if (!HttpParser.isToken(chr)) {
-                    byteBuffer.position(byteBuffer.position() - 1);
+                    ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
                     // Avoid unknown protocol triggering an additional error
                     request.protocol().setString(Constants.HTTP_11);
                     throw new IllegalArgumentException(sm.getString("iib.invalidmethod"));
@@ -432,7 +433,7 @@ public class Http11InputBuffer implement
                 chr = byteBuffer.get();
                 if (!(chr == Constants.SP || chr == Constants.HT)) {
                     space = false;
-                    byteBuffer.position(byteBuffer.position() - 1);
+                    ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
                 }
             }
             parsingRequestLineStart = byteBuffer.position();
@@ -520,7 +521,7 @@ public class Http11InputBuffer implement
                 byte chr = byteBuffer.get();
                 if (!(chr == Constants.SP || chr == Constants.HT)) {
                     space = false;
-                    byteBuffer.position(byteBuffer.position() - 1);
+                    ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
                 }
             }
             parsingRequestLineStart = byteBuffer.position();
@@ -618,7 +619,7 @@ public class Http11InputBuffer implement
 
         if (swallowInput && (lastActiveFilter != -1)) {
             int extraBytes = (int) activeFilters[lastActiveFilter].end();
-            byteBuffer.position(byteBuffer.position() - extraBytes);
+            ((Buffer)byteBuffer).position(byteBuffer.position() - extraBytes);
         }
     }
 
@@ -716,7 +717,7 @@ public class Http11InputBuffer implement
                 wrapper.getSocketBufferHandler().getReadBuffer().capacity();
         if (byteBuffer == null || byteBuffer.capacity() < bufLength) {
             byteBuffer = ByteBuffer.allocate(bufLength);
-            byteBuffer.position(0).limit(0);
+            ((Buffer)byteBuffer).position(0).limit(0);
         }
     }
 
@@ -741,14 +742,14 @@ public class Http11InputBuffer implement
                 throw new IllegalArgumentException(sm.getString("iib.requestheadertoolarge.error"));
             }
         } else {
-            byteBuffer.limit(end).position(end);
+            ((Buffer)byteBuffer).limit(end).position(end);
         }
 
-        byteBuffer.mark();
+        ((Buffer)byteBuffer).mark();
         if (byteBuffer.position() < byteBuffer.limit()) {
-            byteBuffer.position(byteBuffer.limit());
+            ((Buffer)byteBuffer).position(byteBuffer.limit());
         }
-        byteBuffer.limit(byteBuffer.capacity());
+        ((Buffer)byteBuffer).limit(byteBuffer.capacity());
         SocketWrapperBase<?> socketWrapper = this.wrapper;
         int nRead = -1;
         if (socketWrapper != null) {
@@ -756,7 +757,7 @@ public class Http11InputBuffer implement
         } else {
             throw new CloseNowException(sm.getString("iib.eof.error"));
         }
-        byteBuffer.limit(byteBuffer.position()).reset();
+        ((Buffer)byteBuffer).limit(byteBuffer.position()).reset();
         if (nRead > 0) {
             return true;
         } else if (nRead == -1) {
@@ -796,10 +797,10 @@ public class Http11InputBuffer implement
             } else {
                 if (prevChr == Constants.CR) {
                     // Must have read two bytes (first was CR, second was not LF)
-                    byteBuffer.position(byteBuffer.position() - 2);
+                    ((Buffer)byteBuffer).position(byteBuffer.position() - 2);
                 } else {
                     // Must have only read one byte
-                    byteBuffer.position(byteBuffer.position() - 1);
+                    ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
                 }
                 break;
             }
@@ -842,7 +843,7 @@ public class Http11InputBuffer implement
                 // Non-token characters are illegal in header names
                 // Parsing continues so the error can be reported in context
                 headerData.lastSignificantChar = pos;
-                byteBuffer.position(byteBuffer.position() - 1);
+                ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
                 // skipLine() will handle the error
                 return skipLine();
             }
@@ -880,7 +881,7 @@ public class Http11InputBuffer implement
                     chr = byteBuffer.get();
                     if (!(chr == Constants.SP || chr == Constants.HT)) {
                         headerParsePos = HeaderParsePosition.HEADER_VALUE;
-                        byteBuffer.position(byteBuffer.position() - 1);
+                        ((Buffer)byteBuffer).position(byteBuffer.position() - 1);
                         break;
                     }
                 }
@@ -1111,7 +1112,7 @@ public class Http11InputBuffer implement
 
             int length = byteBuffer.remaining();
             handler.setByteBuffer(byteBuffer.duplicate());
-            byteBuffer.position(byteBuffer.limit());
+            ((Buffer)byteBuffer).position(byteBuffer.limit());
 
             return length;
         }
@@ -1133,12 +1134,12 @@ public class Http11InputBuffer implement
     @Override
     public void expand(int size) {
         if (byteBuffer.capacity() >= size) {
-            byteBuffer.limit(size);
+            ((Buffer)byteBuffer).limit(size);
         }
         ByteBuffer temp = ByteBuffer.allocate(size);
         temp.put(byteBuffer);
         byteBuffer = temp;
-        byteBuffer.mark();
+        ((Buffer)byteBuffer).mark();
         temp = null;
     }
 }
Index: apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/Http11OutputBuffer.java
===================================================================
--- apache-tomcat-9.0.33-src.orig/java/org/apache/coyote/http11/Http11OutputBuffer.java
+++ apache-tomcat-9.0.33-src/java/org/apache/coyote/http11/Http11OutputBuffer.java
@@ -17,6 +17,7 @@
 package org.apache.coyote.http11;
 
 import java.io.IOException;
+import java.nio.Buffer;
 import java.nio.ByteBuffer;
 import java.util.Arrays;
 
@@ -242,7 +243,7 @@ public class Http11OutputBuffer implemen
      * headers so the error response can be written.
      */
     void resetHeaderBuffer() {
-        headerBuffer.position(0).limit(headerBuffer.capacity());
+        ((Buffer)headerBuffer).position(0).limit(headerBuffer.capacity());
     }
 
 
@@ -270,7 +271,7 @@ public class Http11OutputBuffer implemen
         // Recycle response object
         response.recycle();
         // Reset pointers
-        headerBuffer.position(0).limit(headerBuffer.capacity());
+        ((Buffer)headerBuffer).position(0).limit(headerBuffer.capacity());
         lastActiveFilter = -1;
         responseFinished = false;
         byteCount = 0;
@@ -302,7 +303,7 @@ public class Http11OutputBuffer implemen
 
         if (headerBuffer.position() > 0) {
             // Sending the response header buffer
-            headerBuffer.flip();
+            ((Buffer)headerBuffer).flip();
             try {
                 SocketWrapperBase<?> socketWrapper = this.socketWrapper;
                 if (socketWrapper != null) {
@@ -311,7 +312,7 @@ public class Http11OutputBuffer implemen
                     throw new CloseNowException(sm.getString("iob.failedwrite"));
                 }
             } finally {
-                headerBuffer.position(0).limit(headerBuffer.capacity());
+                ((Buffer)headerBuffer).position(0).limit(headerBuffer.capacity());
             }
         }
     }
